// Use multiple catch statements.
class ArrayIndexOutOfBoundsExceptionGivesIllegalIndex
{
  public static void main(String[] args)
  {
    // Here, numer is longer than denom.
    // declare and populate an array
    // for numerator, then for denominator
    int numer[] = { 4, 8, 16, 32, 64, 128, 256, 512, -22 }; // 9 indices
    int denom[] = { 2, 0, 4, 4, 0, 8 }; // 6 indices

    for(int i=0; i<numer.length; i++)
    {
      try
      {
         System.out.println(numer[i] + " / " +
                           denom[i] + " is " +
                           numer[i]/denom[i]);
       }
       catch(ArrayIndexOutOfBoundsException exc)
       {
         // catch the exception
         System.out.println("No matching element found.");
         exc.printStackTrace();
       }
       // unreachable code
       catch(ArithmeticException exc)
       {
         // catch the exception
         System.out.println("Can't divide by Zero!");
         exc.printStackTrace();
       }
       catch(Exception exc)
       {
          // catch the exception
          System.out.println("Catch any exception.");
          exc.printStackTrace();
       }
    } // for
  }  // main
}
/* Note that the illegal index is indicated, such 6, 7, or 8.
http://docs.oracle.com/javase/7/docs/api/java/lang/ArrayIndexOutOfBoundsException.html#ArrayIndexOutOfBoundsException%28int%29 */