/* Copy a text file.
   java CopyFile SOURCE.TXT DESTINATION.TXT
*/

import java.io.*;

class CopyFile
{
  public static void main(String[] args)
  {
    int i;
    FileInputStream fin;
    FileOutputStream fout;

    // First make sure that both files have been specified.
    if(args.length !=2 )
    {
      System.out.println("Usage: CopyFile From To");
      return;
    }
    // open input file, the source
    try
    {
      fin = new FileInputStream(args[0]);
    }
    catch(FileNotFoundException exc)
    {
      System.out.println("Input File Not Found");
      return;
    }
    // open output file, the destination
    try
    {
      fout = new FileOutputStream(args[1]);
    }
    catch(FileNotFoundException exc)
    {
      System.out.println("Error Opening Output File");

      // Close the open input file.
      try
      {
        fin.close();
      }
      catch(IOException exc2)
      {
        System.out.println("Error closing input file.");
      }
      return;
    }

    // Copy File
    try
    {
      do
      {
		// read byte by byte under end of file returns -1
		// http://docs.oracle.com/javase/7/docs/api/java/io/FileInputStream.html#read%28%29
        i = fin.read();
        if(i != -1)
        {  // write that byte to destination file
           // where byte is promoted is int
			fout.write(i);
		}
      }
      while(i != -1);
    }
    catch(IOException exc)
    {
      System.out.println("File Error");
    }
    try
    {
      fin.close();
    }
    catch(IOException exc)
    {
      System.out.println("Error closing input file.");
    }
    try
    {
      fout.close();
    }
    catch(IOException exc)
    {
      System.out.println("Error closing output file.");
    }
  }
}