// Define, throw, and catch a custom exception.
class NonIntegerResultException extends Exception
{
  int n;
  int d;
  NonIntegerResultException(int i, int j)
  {
    n = i;
    d = j;
  }
  public String toString()
  {
    return "Result of " + n + " / " + d +
           " is non-integer.";
  }
}
class CustomException
{
  public static void main(String[] args)
  {
    // Here, numer contains some odd values.
    int numer[] = { 4, 8, 15, 32, 64, 127, 256, 512 };
    int denom[] = { 2, 0, 4, 4, 0, 8 };
    for(int i=0; i<numer.length; i++)
    {
      try
      {
        if((numer[i]%2) != 0)
          throw new NonIntegerResultException(numer[i], denom[i]);

        System.out.println(numer[i] + " / " +
                           denom[i] + " is " +
                           numer[i]/denom[i]);
      }
      catch (ArithmeticException exc)
      {
        // catch the exception
        System.out.println("Can't divide by Zero!");
      }
      catch (ArrayIndexOutOfBoundsException exc)
      {
        // catch the exception
        System.out.println("No matching element found.");
      }
      catch (NonIntegerResultException exc)
      {
        System.out.println(exc);
      }
    }
  }
}