// Custom subclass of Exception. Execution continues past first error.
// How come NegativeArraySizeException does get thrown?
class ThomasException extends Exception
{
   ThomasException()
   {
      System.out.println("ThomasException has been thrown.");
   }
}
class DemoThomasExceptionSpecial
{
   public static void main(String[] args)
   {
      int size;
      for(size = 3; size > -3; size--)
      {
         try
         {
            System.out.println("size = " + size);
            if (size == -1)
            {
               // call the default constructor
               // of the Exception subclass
               // when throwing
               throw new ThomasException();
            }
            int myArray[] = new int[size];
            System.out.println("length is: " + myArray.length);
         }
         catch (NegativeArraySizeException  e)
         {
            System.out.println("Negative array " + e.toString());
         }
         catch (ThomasException e)
         {
             System.out.println("ThomasException is " + e.toString());
         }
      }
   }
}
/* because NegativeArraySizeException is a "unchecked" exception thrown by the JVM */